"use strict";var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports.SetPassword=void 0;var _extends2=_interopRequireDefault(require("@babel/runtime/helpers/extends"));var _slicedToArray2=_interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));var _react=_interopRequireWildcard(require("react"));var _PasswordRequirements=_interopRequireDefault(require("./PasswordRequirements"));var _reactNativePaper=require("react-native-paper");var _useScreenDimensions2=require("../../hooks/useScreenDimensions");var _reactNative=require("react-native");var _constants=require("../../constants");var _reactI18next=require("react-i18next");var _PasswordTextField=require("./PasswordTextField");var _reactNativeThemes=require("@brightlayer-ui/react-native-themes");var _jsxFileName="/home/runner/work/blui-react-native-workflows/blui-react-native-workflows/login-workflow/src/components/SetPassword/SetPassword.tsx";function _getRequireWildcardCache(e){if("function"!=typeof WeakMap)return null;var r=new WeakMap(),t=new WeakMap();return(_getRequireWildcardCache=function _getRequireWildcardCache(e){return e?t:r;})(e);}function _interopRequireWildcard(e,r){if(!r&&e&&e.__esModule)return e;if(null===e||"object"!=typeof e&&"function"!=typeof e)return{default:e};var t=_getRequireWildcardCache(r);if(t&&t.has(e))return t.get(e);var n={__proto__:null},a=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var u in e)if("default"!==u&&{}.hasOwnProperty.call(e,u)){var i=a?Object.getOwnPropertyDescriptor(e,u):null;i&&(i.get||i.set)?Object.defineProperty(n,u,i):n[u]=e[u];}return n.default=e,t&&t.set(e,n),n;}var makeStyles=function makeStyles(isTablet,theme){return _reactNative.StyleSheet.create({passwordRequirementContainer:{marginTop:8,marginBottom:isTablet?32:24},errorHelperText:{marginBottom:8},successHelperText:{marginBottom:8,color:theme.colors.success}});};var SetPassword=exports.SetPassword=function SetPassword(props){var _props$newPasswordLab=props.newPasswordLabel,newPasswordLabel=_props$newPasswordLab===void 0?'Password':_props$newPasswordLab,_props$initialNewPass=props.initialNewPasswordValue,initialNewPasswordValue=_props$initialNewPass===void 0?'':_props$initialNewPass,_props$confirmPasswor=props.confirmPasswordLabel,confirmPasswordLabel=_props$confirmPasswor===void 0?'Confirm':_props$confirmPasswor,_props$initialConfirm=props.initialConfirmPasswordValue,initialConfirmPasswordValue=_props$initialConfirm===void 0?'':_props$initialConfirm,passwordRequirements=props.passwordRequirements,onPasswordChange=props.onPasswordChange,children=props.children,passwordRef=props.passwordRef,confirmRef=props.confirmRef,passwordNotMatchError=props.passwordNotMatchError,onSubmit=props.onSubmit,passwordTextFieldProps=props.passwordTextFieldProps,confirmPasswordTextFieldProps=props.confirmPasswordTextFieldProps;var _useTranslation=(0,_reactI18next.useTranslation)(),t=_useTranslation.t;var _useState=(0,_react.useState)(initialNewPasswordValue),_useState2=(0,_slicedToArray2.default)(_useState,2),passwordInput=_useState2[0],setPasswordInput=_useState2[1];var _useState3=(0,_react.useState)(initialConfirmPasswordValue),_useState4=(0,_slicedToArray2.default)(_useState3,2),confirmInput=_useState4[0],setConfirmInput=_useState4[1];var _useScreenDimensions=(0,_useScreenDimensions2.useScreenDimensions)(),isTablet=_useScreenDimensions.isTablet;var theme=(0,_reactNativeThemes.useExtendedTheme)();var defaultStyle=makeStyles(isTablet,theme);(0,_react.useEffect)(function(){setPasswordInput(initialNewPasswordValue);setConfirmInput(initialConfirmPasswordValue);},[initialNewPasswordValue,initialConfirmPasswordValue]);var onPassChange=(0,_react.useCallback)(function(newPassword){setPasswordInput(newPassword);onPasswordChange===null||onPasswordChange===void 0||onPasswordChange({password:newPassword,confirm:confirmInput});},[setPasswordInput,onPasswordChange,confirmInput]);var onConfirmChange=(0,_react.useCallback)(function(newConfirm){setConfirmInput(newConfirm);onPasswordChange===null||onPasswordChange===void 0||onPasswordChange({password:passwordInput,confirm:newConfirm});},[setConfirmInput,onPasswordChange,passwordInput]);var hasConfirmPasswordError=(0,_react.useCallback)(function(){return passwordInput.length!==0&&confirmInput.length!==0&&confirmInput!==passwordInput;},[confirmInput,passwordInput]);var isValidPassword=(0,_react.useCallback)(function(){var requirementsToCheck=passwordRequirements?passwordRequirements:(0,_constants.defaultPasswordRequirements)(t);for(var i=0;i<requirementsToCheck.length;i++){if(!new RegExp(requirementsToCheck[i].regex).test(passwordInput))return false;}return true;},[passwordRequirements,t,passwordInput]);return _react.default.createElement(_react.default.Fragment,null,children,_react.default.createElement(_PasswordTextField.PasswordTextField,(0,_extends2.default)({testID:"blui-set-password-password-text-field",label:newPasswordLabel,value:passwordInput,ref:passwordRef,error:passwordInput!==''&&!isValidPassword()},passwordTextFieldProps,{onChangeText:function onChangeText(text){(passwordTextFieldProps===null||passwordTextFieldProps===void 0?void 0:passwordTextFieldProps.onChangeText)&&passwordTextFieldProps.onChangeText(text);onPassChange(text);},returnKeyType:"next",onSubmitEditing:function onSubmitEditing(){var _confirmRef$current;return confirmRef===null||confirmRef===void 0||(_confirmRef$current=confirmRef.current)===null||_confirmRef$current===void 0?void 0:_confirmRef$current.focus();},__source:{fileName:_jsxFileName,lineNumber:99,columnNumber:13}})),_react.default.createElement(_PasswordRequirements.default,{passwordText:passwordInput,passwordRequirements:passwordRequirements,style:defaultStyle.passwordRequirementContainer,__source:{fileName:_jsxFileName,lineNumber:114,columnNumber:13}}),_react.default.createElement(_PasswordTextField.PasswordTextField,(0,_extends2.default)({testID:"blui-set-password-confirm-password-text-field",label:confirmPasswordLabel,value:confirmInput,ref:confirmRef,error:hasConfirmPasswordError()},confirmPasswordTextFieldProps,{onChangeText:function onChangeText(text){(confirmPasswordTextFieldProps===null||confirmPasswordTextFieldProps===void 0?void 0:confirmPasswordTextFieldProps.onChangeText)&&confirmPasswordTextFieldProps.onChangeText(text);onConfirmChange(text);},returnKeyType:"done",onSubmitEditing:function onSubmitEditing(){if(!hasConfirmPasswordError()&&isValidPassword()&&onSubmit)onSubmit();},__source:{fileName:_jsxFileName,lineNumber:119,columnNumber:13}})),hasConfirmPasswordError()&&_react.default.createElement(_reactNativePaper.HelperText,{type:"error",visible:hasConfirmPasswordError(),style:defaultStyle.errorHelperText,__source:{fileName:_jsxFileName,lineNumber:137,columnNumber:17}},passwordNotMatchError||t('bluiCommon:FORMS.PASS_MATCH_ERROR')),!hasConfirmPasswordError()&&confirmInput!==''&&confirmInput===passwordInput&&_react.default.createElement(_reactNativePaper.HelperText,{type:"info",visible:!hasConfirmPasswordError()&&confirmInput!==''&&confirmInput===passwordInput,style:defaultStyle.successHelperText,__source:{fileName:_jsxFileName,lineNumber:142,columnNumber:17}},t('bluiCommon:FORMS.PASS_MATCH')));};
//# sourceMappingURL=SetPassword.js.map